alert("======  ButtonBase.js    ========");

var BUTTON_BASE_TYPE = { 
 
 	ONLY_BG		: 0,
 	BG_TEXT		: 1,
	BG_FG		: 2, 	
	BG_FG_TEXT	: 3,
}

var BUTTON_BASE_STATE = { 
 
 	NORMAL		: 0,
 	HIGHLIGHT	: 1,
	SELECT		: 2, 	
	DIM			: 3,
	MAX			: 4
}


function ButtonBase() {

  	this.FgImgLayerIndex	= -1;		//Fg Image 
    this.TextLayerIndex		= -1;
    
	this.BgImgPath = new Array(BUTTON_BASE_STATE.MAX);
	this.FgImgPath = new Array(BUTTON_BASE_STATE.MAX);
	  
	this.TextStyle = new Array(BUTTON_BASE_STATE.MAX);
	this.BgImgStyle = new Array(BUTTON_BASE_STATE.MAX);
	this.FgImgStyle = new Array(BUTTON_BASE_STATE.MAX);
   
	this.buttonType = BUTTON_BASE_TYPE.ONLY_BG;
	this.state = BUTTON_BASE_STATE.NORMAL;
	
	this.onClickCallbackFunc = null;
	this.flagClickEnable = false;
	CompBase.call(this);
}


ButtonBase.prototype = new CompBase(); 

ButtonBase.prototype.Create = function(eID,nType){
	
 //   alert("ButtonBase.Create(" + eID + ")");
    if(eID == null) {
        alert("ButtonBase.Create()  >>>   Param is null !!  ");
        return false;
    }
    	
	this.CreateBG(eID);	
	this.SetID(eID);
	if(nType > 1) {
		this.CreateFG(eID + "Fg");	
	}
	if((nType % 2) > 0) {
		this.CreateText(eID + "Text");
	}		
}

ButtonBase.prototype.CreateFG = function(eID){

    var imageLayer = new ImageLayer(eID);
    
	this.FgImgLayerIndex = this.LayerArray.length;
	
    this.InsertLayer(imageLayer);
}


ButtonBase.prototype.AppendFgImage = function(id,h_space, v_space, w, h, img_src)
{
	this.LayerArray[this.FgImgLayerIndex].AppendFgImage(id,h_space, v_space, w, h, img_src);
}


ButtonBase.prototype.CreateText = function(eID){
    var textLayer = new TextLayer(eID);
    
	this.TextLayerIndex = this.LayerArray.length;
	
	
    this.InsertLayer(textLayer);
	
}


ButtonBase.prototype.SetBgImage = function(stateIndex, ImagePath)
{
	this.BgImgPath[stateIndex] = ImagePath;
	this.LayerArray[this.BGLayerIndex].SetImage(ImagePath);
}

ButtonBase.prototype.SetFgImage = function(stateIndex,ImagePath){
	//alert("ButtonBase.prototype.SetFgImage stateIndex::" + stateIndex);
	if (stateIndex == -1) {
		this.LayerArray[this.FgImgLayerIndex].SetFgImage(ImagePath);
	}
	else {
		this.FgImgPath[stateIndex] = ImagePath;
		
		if (stateIndex == BUTTON_BASE_STATE.NORMAL) {
			this.LayerArray[this.FgImgLayerIndex].SetImage(ImagePath);
		}
	}
}



ButtonBase.prototype.visibleFgObj=function()
{
    //alert("ImageLayer.prototype.visibleFgObj()");
    this.LayerArray[this.FgImgLayerIndex].visibleFgObj();
}

ButtonBase.prototype.hiddenFgObj=function(){
   // alert("ButtonBase.prototype.hiddenFgObj()");
   this.LayerArray[this.FgImgLayerIndex].hiddenFgObj();

}





ButtonBase.prototype.SetBgStyle = function(stateIndex,Style){
    
    this.BgImgStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.BGLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetFgStyle = function(stateIndex,Style){
    
      this.FgImgStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.FgImgLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetTextStyle = function(stateIndex,Style){
    
    this.TextStyle[stateIndex] = Style;
    
    if(stateIndex == BUTTON_BASE_STATE.NORMAL)
    {
		this.LayerArray[this.TextLayerIndex].SetStyle(Style);		
    }
}

ButtonBase.prototype.SetText = function(string){
	
	if(this.TextLayerIndex > 0)  
	{
		this.LayerArray[this.TextLayerIndex].SetText(string);
	}

}

ButtonBase.prototype.highlight = function(){
    this.state    = BUTTON_BASE_STATE.HIGHLIGHT;
	this.ChangeMode();
	
}

ButtonBase.prototype.ChangeMode = function() {
	var curState = this.state;
	
	
//	alert("this.LayerArray.length :: " + this.LayerArray.length);
//	alert("curState  ::::  " + curState);
//	
//	
//	alert("this.BgImgStyle[curState] :: " + this.BgImgStyle[curState]);
//	alert("this.TextStyle[curState] :: " + this.TextStyle[curState]);
//	alert("this.FgImgStyle[curState] :: " + this.FgImgStyle[curState]);
//	alert("this.BgImgPath[curState] :: " + this.BgImgPath[curState]);
//	alert("this.FgImgPath[curState] :: " + this.FgImgPath[curState]);
	
	
	if(this.BgImgStyle[curState]){
//		alert("this.BgImgStyle[curState] :: " + this.BgImgStyle[curState]);
		this.LayerArray[this.BGLayerIndex].SetStyle(this.BgImgStyle[curState]);
	}
	
	if(this.TextStyle[curState]){
//		alert("this.TextStyle[curState] :: " + this.TextStyle[curState]);
		this.LayerArray[this.TextLayerIndex].SetStyle(this.TextStyle[curState]);
	}
	
	if(this.FgImgStyle[curState]){
//		alert("this.FgImgStyle[curState] :: " + this.FgImgStyle[curState]);
		this.LayerArray[this.FgImgLayerIndex].SetStyle(this.FgImgStyle[curState]);

	}	
	
	if(this.BgImgPath[curState]) {
//		alert("BgImgPath");
		this.LayerArray[this.BGLayerIndex].SetImage(this.BgImgPath[curState]);		
	}
	
	if(this.FgImgPath[curState]){
//		alert("FgImgPath");
//		alert("this.LayerArray[this.FgImgLayerIndex] ::" + this.LayerArray[this.FgImgLayerIndex]);
		this.LayerArray[this.FgImgLayerIndex].SetImage(this.FgImgPath[curState]);	
	}
}

ButtonBase.prototype.blur = function(){
    this.state    = BUTTON_BASE_STATE.NORMAL;
	this.ChangeMode();
}

ButtonBase.prototype.select = function(){
    this.state    = BUTTON_BASE_STATE.SELECT;
	this.ChangeMode();
}

ButtonBase.prototype.dim = function(){
//	alert("ButtonBase.prototype.dim");
    this.state    = BUTTON_BASE_STATE.DIM;
	this.ChangeMode();
}

ButtonBase.prototype.SetID = function(nID){
    this.ID = nID;
}

ButtonBase.prototype.GetID = function(){
    return this.ID;
}

ButtonBase.prototype.GetState = function(){
    return this.state;
}



////////////////////////////////////////
//    Mouse EVENT
////////////////////////////////////////

ButtonBase.prototype.SetOnClickCallbackFunc = function(func)
{
	alert("==== SetOnClickCallbackFunc () : func = "+func);
	this.onClickCallbackFunc = func;
	this.EnableOnClick();
}

ButtonBase.prototype.EnableOnClick = function()
{
	alert("==== EnableOnClick () : this.flagClickEnable = "+this.flagClickEnable);
	if(this.flagClickEnable == false)
	{
		var object = this.GetID();
		alert("==== EnableOnClick () : object = "+object);
		
		var this_ = this;
		document.getElementById(object).onclick = function()
		{
			alert('==== onclick');
			this_.onClickCallbackFunc(this_);
		};
		this.flagClickEnable = true;
		$("#"+object).css({'cursor' : 'pointer'});	
	}
}

ButtonBase.prototype.DisableOnClick = function()
{
	alert("==== DisableOnClick () : this.flagClickEnable = "+this.flagClickEnable);
	if(this.flagClickEnable == true)
	{
		var object = this.GetID();
		document.getElementById(object).onclick = null;
		this.flagClickEnable = false;
		$("#"+object).css({'cursor' : ''});	 
	}
}


