alert("======  NinePathPopup.js  ========");

var BUTTON_TYPE = 
{ 
 	ONE		: 0,
 	TWO		: 1,
}

var POPUP_IMG_TYPE = 
{ 
 	NINE		: 0,
 	THREE		: 1,
}

function NinePatchPopup(eID, popup_style, btn_style)
{
	this.ID = eID;
	this.PopupStyle = popup_style;
	this.BtnStyle = null;

	this.TopImageLayer = new Array(3);
	this.TopAlphaLayer = new Array(3);
		
	alert("==== NinePatchPopup : this.PopupStyle = "+this.PopupStyle);
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.BtnStyle = btn_style;
		this.CenterImageLayer = new Array(3);
		this.BottomImageLayer = new Array(3);
	
		this.CenterAlphaLayer = new Array(3);
		this.BottomAlphaLayer = new Array(3);
	}
	this.Create();
}

NinePatchPopup.prototype.Create = function()
{
	this.TopImageLayer[0] = new ImageLayer(this.ID + "_bg_top_l");
	this.TopImageLayer[1] = new ImageLayer(this.ID + "_bg_top_c");
	this.TopImageLayer[2] = new ImageLayer(this.ID + "_bg_top_r");

	
	this.TopAlphaLayer[0] = new ImageLayer(this.ID + "_alpha_top_l");
	this.TopAlphaLayer[1] = new ImageLayer(this.ID + "_alpha_top_c");
	this.TopAlphaLayer[2] = new ImageLayer(this.ID + "_alpha_top_r");
	
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.CenterImageLayer[0] = new ImageLayer(this.ID + "_bg_middle_l");
		this.CenterImageLayer[1] = new ImageLayer(this.ID + "_bg_middle_c");
		this.CenterImageLayer[2] = new ImageLayer(this.ID + "_bg_middle_r");
	
		this.BottomImageLayer[0] = new ImageLayer(this.ID + "_bg_bottom_l");
		this.BottomImageLayer[1] = new ImageLayer(this.ID + "_bg_bottom_c");
		this.BottomImageLayer[2] = new ImageLayer(this.ID + "_bg_bottom_r");
	
		this.CenterAlphaLayer[0] = new ImageLayer(this.ID + "_alpha_middle_l");
		this.CenterAlphaLayer[1] = new ImageLayer(this.ID + "_alpha_middle_c");
		this.CenterAlphaLayer[2] = new ImageLayer(this.ID + "_alpha_middle_r");
	
		this.BottomAlphaLayer[0] = new ImageLayer(this.ID + "_alpha_bottom_l");
		this.BottomAlphaLayer[1] = new ImageLayer(this.ID + "_alpha_bottom_c");
		this.BottomAlphaLayer[2] = new ImageLayer(this.ID + "_alpha_bottom_r");
	}
}


NinePatchPopup.prototype.SetTopBgImage = function(path1, path2, path3)
{
	/*
	alert("==== NinePatchPopup.SetTopBgImage : path1 = "+path1);
	alert("==== NinePatchPopup.SetTopBgImage : path2 = "+path2);
	alert("==== NinePatchPopup.SetTopBgImage : path3 = "+path3);
	*/
	
	this.TopImageLayer[0].SetImage(path1);
	this.TopImageLayer[1].SetImage(path2);
	this.TopImageLayer[2].SetImage(path3);
}

NinePatchPopup.prototype.SetCenterBgImage = function(path1, path2, path3)
{
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.CenterImageLayer[0].SetImage(path1);
		this.CenterImageLayer[1].SetImage(path2);
		this.CenterImageLayer[2].SetImage(path3);
	}
}

NinePatchPopup.prototype.SetBottomBgImage = function(path1, path2, path3)
{
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.BottomImageLayer[0].SetImage(path1);
		this.BottomImageLayer[1].SetImage(path2);
		this.BottomImageLayer[2].SetImage(path3);
	}
}



NinePatchPopup.prototype.SetTopAlphaImage = function(path1, path2, path3)
{
	/*
	alert("==== NinePatchPopup.SetTopAlphaImage : path1 = "+path1);
	alert("==== NinePatchPopup.SetTopAlphaImage : path2 = "+path2);
	alert("==== NinePatchPopup.SetTopAlphaImage : path3 = "+path3);
	*/
	
	this.TopAlphaLayer[0].SetImage(path1);
	this.TopAlphaLayer[1].SetImage(path2);
	this.TopAlphaLayer[2].SetImage(path3);
}

NinePatchPopup.prototype.SetCenterAlphaImage = function(path1, path2, path3)
{
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.CenterAlphaLayer[0].SetImage(path1);
		this.CenterAlphaLayer[1].SetImage(path2);
		this.CenterAlphaLayer[2].SetImage(path3);
	}
}

NinePatchPopup.prototype.SetBottomAlphaImage = function(path1, path2, path3)
{
	if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		this.BottomAlphaLayer[0].SetImage(path1);
		this.BottomAlphaLayer[1].SetImage(path2);
		this.BottomAlphaLayer[2].SetImage(path3);
	}
}


NinePatchPopup.prototype.SetSize = function(w, h)
{
	//NINE : 34px
	//THREE : 24px
	
	var intW = parseInt(w);
	var intH = parseInt(h);
	
	if (this.PopupStyle == POPUP_IMG_TYPE.THREE) 
	{
		var popupLeft = parseInt((1280 - intW) - 5);

		var centerWidth = intW - 48;
		var rightLeft = intW - 24;
		
		var textWidth = intW - 66;

		$("#" + this.ID).css("left", popupLeft + "px");
		
		$("#" + this.ID + "_bg_top_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_bg_top_r").css("left", rightLeft + "px");
		
		$("#" + this.ID + "_alpha_top_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_alpha_top_r").css("left", rightLeft + "px");
		
		$("#" + this.ID + "_text").css("width", textWidth + "px");
				
	}
	else if (this.PopupStyle == POPUP_IMG_TYPE.NINE) 
	{
		var popupLeft = parseInt((1280 - intW) / 2);
		var popupTop = parseInt((720 - intH) / 2);
		var centerWidth = intW - 68;
		var rightLeft = intW - 34;
		var middleHeight = intH - 167;
		var bottomTop = middleHeight + 90;
		var textWidth = centerWidth;
		if (g_Data.FollowTV.LANG == "ko") 
		{
			textWidth = centerWidth - 70;
			var textLeft = 41+35;
			$("#" + this.ID + "_text").css("left", textLeft + "px");
		}
		
		
		
		$("#" + this.ID).css("left", popupLeft + "px");
		$("#" + this.ID).css("top", popupTop + "px");
		$("#" + this.ID).css("width", intW + "px");
		$("#" + this.ID).css("height", intH + "px");
		
		$("#" + this.ID + "_bg_top_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_bg_top_r").css("left", rightLeft + "px");
		$("#" + this.ID + "_alpha_top_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_alpha_top_r").css("left", rightLeft + "px");
		
		$("#" + this.ID + "_bg_middle").css("height", middleHeight + "px");
		$("#" + this.ID + "_bg_middle_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_bg_middle_r").css("left", rightLeft + "px");
		$("#" + this.ID + "_bg_bottom").css("top", bottomTop + "px");
		$("#" + this.ID + "_bg_bottom_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_bg_bottom_r").css("left", rightLeft + "px");
		$("#" + this.ID + "_alpha_middle").css("height", middleHeight + "px");
		$("#" + this.ID + "_alpha_middle_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_alpha_middle_r").css("left", rightLeft + "px");
		$("#" + this.ID + "_alpha_bottom").css("top", bottomTop + "px");
		$("#" + this.ID + "_alpha_bottom_c").css("width", centerWidth + "px");
		$("#" + this.ID + "_alpha_bottom_r").css("left", rightLeft + "px");
		
		//if Text
	
		$("#" + this.ID + "_text").css("width", textWidth + "px");
		
		//if Button
		var btnTop = intH - 82;
		if (this.BtnStyle == BUTTON_TYPE.ONE) 
		{
			var btnLeft = parseInt((intW - 161) / 2);
			$("#" + this.ID + "_ok").css("left", btnLeft + "px");
			$("#" + this.ID + "_ok").css("top", btnTop + "px");
		}
		else if (this.BtnStyle == BUTTON_TYPE.TWO) 
		{
			var btnLeft = parseInt((intW - 327) / 2);
			$("#" + this.ID + "_twobtn").css("left", btnLeft + "px");
			$("#" + this.ID + "_twobtn").css("top", btnTop + "px");
		}
	}
	
	
}

NinePatchPopup.prototype.GetID = function()
{
	return this.ID;
}
