alert("======  ThreeImageButton.js    ========");

var BUTTON_BASE_STATE = 
{ 
 	NORMAL		: 0,
 	HIGHLIGHT	: 1,
	SELECT		: 2, 	
	DIM			: 3,
	MAX			: 4
}


function ThreeImageButton()
{
	this.ImageLayer = new Array(3);
	
	this.ImagePathArray = new Array(BUTTON_BASE_STATE.MAX);
	this.ImagePathArray[BUTTON_BASE_STATE.NORMAL] = new Array(3);
	this.ImagePathArray[BUTTON_BASE_STATE.HIGHLIGHT] = new Array(3);
	this.ImagePathArray[BUTTON_BASE_STATE.SELECT] = new Array(3);
	this.ImagePathArray[BUTTON_BASE_STATE.DIM] = new Array(3);
	
	
	this.TextLayer = null;
	this.TextStyleArray = new Array(BUTTON_BASE_STATE.MAX);
	
	
	this.onClickCallbackFunc = null;
	this.flagClickEnable = false;
}

ThreeImageButton.prototype.Create = function(eID)
{
	this.ImageLayer[0] = new ImageLayer(eID + "_frame_1");
	this.ImageLayer[1] = new ImageLayer(eID + "_frame_2");
	this.ImageLayer[2] = new ImageLayer(eID + "_frame_3");
	
	this.SetID(eID);
	this.CreateText(eID+"_text");
}


ThreeImageButton.prototype.SetThreeBgImage = function(stateIndex, path1, path2, path3)
{
    this.ImagePathArray[stateIndex][0] = path1;
	this.ImagePathArray[stateIndex][1] = path2;
	this.ImagePathArray[stateIndex][2] = path3;
	
	if (stateIndex == BUTTON_BASE_STATE.NORMAL)
	{
		this.ImageLayer[0].SetImage(this.ImagePathArray[stateIndex][0]);
		this.ImageLayer[1].SetImage(this.ImagePathArray[stateIndex][1]);
		this.ImageLayer[2].SetImage(this.ImagePathArray[stateIndex][2]);
	}
}


ThreeImageButton.prototype.CreateText = function(eID)
{
	this.TextLayer = new TextLayer(eID);
}

ThreeImageButton.prototype.SetText = function(string)
{
	this.TextLayer.SetText(string);
}

ThreeImageButton.prototype.SetTextStyle = function(stateIndex, Style)
{
	this.TextStyleArray[stateIndex] = Style;
	
	if (stateIndex == BUTTON_BASE_STATE.NORMAL)
	{
		this.TextLayer.SetTextStyle(this.TextStyleArray[stateIndex]);
	}
}


ThreeImageButton.prototype.highlight = function()
{
	alert("ThreeImageButton.highlight");
	this.state = BUTTON_BASE_STATE.HIGHLIGHT;
	this.ChangeMode();
}

ThreeImageButton.prototype.blur = function()
{
	alert("ThreeImageButton.blur");
	this.state = BUTTON_BASE_STATE.NORMAL;
	this.ChangeMode();
}

ThreeImageButton.prototype.select = function()
{
	alert("ThreeImageButton.select");
	this.state = BUTTON_BASE_STATE.SELECT;
	this.ChangeMode();
}

ThreeImageButton.prototype.dim = function()
{
	alert("ThreeImageButton.dim");
	this.state = BUTTON_BASE_STATE.DIM;
	this.ChangeMode();
}

ThreeImageButton.prototype.ChangeMode = function()
{
	alert("ThreeImageButton.ChangeMode");
	var curState = this.state;

	if (this.TextStyleArray[curState]) 
	{
		alert("==== ThreeImageButton.ChangeMode : this.TextStyleArray["+curState+"] = "+this.TextStyleArray[curState]);
		this.TextLayer.SetStyle(this.TextStyleArray[curState]);
	}
	
	if (this.ImagePathArray[curState][0] && this.ImagePathArray[curState][1] && this.ImagePathArray[curState][2] ) 
	{
		this.ImageLayer[0].SetImage(this.ImagePathArray[curState][0]);
		this.ImageLayer[1].SetImage(this.ImagePathArray[curState][1]);
		this.ImageLayer[2].SetImage(this.ImagePathArray[curState][2]);
	}
}


ThreeImageButton.prototype.SetID = function(nID)
{
	this.ID = nID;
}

ThreeImageButton.prototype.GetID = function()
{
	return this.ID;
}

ThreeImageButton.prototype.GetState = function()
{
	return this.state;
}



////////////////////////////////////////
//    Mouse EVENT
////////////////////////////////////////

ThreeImageButton.prototype.SetOnClickCallbackFunc = function(func)
{
	alert("==== ThreeImageButton.SetOnClickCallbackFunc () : func = "+func);
	this.onClickCallbackFunc = func;
	this.EnableOnClick();
}

ThreeImageButton.prototype.EnableOnClick = function()
{
	alert("==== ThreeImageButton.EnableOnClick () : this.flagClickEnable = "+this.flagClickEnable);
	if(this.flagClickEnable == false)
	{
		var object = this.GetID();
		alert("==== ThreeImageButton.EnableOnClick () : object = "+object);
		
		var this_ = this;
		document.getElementById(object).onclick = function()
		{
			alert('==== ThreeImageButton.onclick');
			this_.onClickCallbackFunc(this_);
		};
		this.flagClickEnable = true;
		$("#"+object).css({'cursor' : 'pointer'});	
	}
}

ThreeImageButton.prototype.DisableOnClick = function()
{
	alert("==== ThreeImageButton.DisableOnClick () : this.flagClickEnable = "+this.flagClickEnable);
	if(this.flagClickEnable == true)
	{
		var object = this.GetID();
		document.getElementById(object).onclick = null;
		this.flagClickEnable = false;
		$("#"+object).css({'cursor' : ''});	 
	}
}
