/*	file	:	CameraIME.js
 *  author	:	@Samsung
 */
 
var ime = null;
 
var Input  = function(id, previousId, nextId)
{
    var imeReady = function(imeObject)
    {
        alert("[TestIME] --- imeReady");
        installFocusKeyCallbacks();
        installStatusCallbacks();
        IME_Load.ready(id);        
    }
    
    ime = new IMEShell(id, imeReady, 'en');
    var element = _$(id);
    var previousElement = _$(previousId);
    var nextElement = _$(nextId);

    var installFocusKeyCallbacks = function()
    {
        ime.setKeyFunc(29460, function(keyCode) {       
            previousElement.focus();
            return false;
        });
		
        ime.setKeyFunc(29461, function(keyCode) {
            nextElement.focus();
            return false;
        });
        
        ime.setKeyFunc(88, function(keyCode) 
        { 
			event.preventDefault();
			IME_Load.returnFunc();                                       
			return false; 
        });
		
        ime.setKeyFunc(45, function(keyCode) 
        { 
			event.preventDefault();
			IME_Load.exitFunc();                                       
			return false; 
        });		
    }
    
    var installStatusCallbacks = function()
    {
        ime.setKeySetFunc('qwerty');
		ime.setKeypadPos(575, 96);
		ime.setQWERTYPos(575, 96);
		ime.setAnyKeyFunc(onAnyKey);
        ime.setMaxLengthFunc(onMaxLength);
        ime.setPrevEventOnLeftFunc(onLeft);
        ime.setOnCompleteFunc(onComplete);
        ime.setEnterFunc(onEnter);
        ime.setKeyFunc($.sfKey.KEY_INFO, onInfoKey);
		ime.setKeypadChangeFunc('12key',move12KeyPosition);
		ime.setKeypadChangeFunc('qwerty',moveqwertyPosition);
		ime.setInputHighlightFunc(ime_onInputHighlight); 
     
    }
    
    var onAnyKey = function(keyCode)
    {
		alert("IMEIMEIMEIMEIME : On Any key pressed");
		alert("Key pressed, code " + keyCode);
		var popupObj = $.sfScene.get('G_PopUp');
		popupObj.restartTimeout();
    }
    
    var onMaxLength = function()
    {
        alert("Maximum length of input reached in " + element.id + ", text is " + element.value);
    }
    
    var onLeft = function()
    {
        alert("Left key pressed at start of " + element.id);
    }
    
	var ime_onInputHighlight = function (keySet, focusObj){
	    alert("[FS_CommonIME]ime_onInputHighlight() START%%%%%%%%%%%%");
	    if(keySet == "qwerty" && focusObj != "inputobj"){
	        alert("[FS_CommonIME] Focused on IME");
			if(_$('InputBoxWndSel')!=null) {
				_$('InputBoxWndSel').style.visibility = "hidden";
			}
	    }else{
	        alert("[FS_CommonIME] Focused on Input");
			if(_$('InputBoxWndSel')!=null) {
				_$('InputBoxWndSel').style.visibility = "visible";
			}
	    }       
	    alert("[FS_CommonIME]ime_onInputHighlight() END%%%%%%%%%%");
	}
	
    var onComplete = function()
    {
		var popupObj = $.sfScene.get('G_PopUp');
		popupObj.restartTimeout();
		     
		alert("Letter entry completed in " + element.id + ", text is " + element.value);
		_$(element.id).innerHTML = "" + element.value + "";
		imeRetrunString = element.value;
		_$('popUpETTNum').set('text',""+imeRetrunString.length+"/50");  			
	}
    
    var onEnter = function(string)
    {
        alert("Enter key pressed in " + element.id + ", string is " + string);
		PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
		$("#"+ element.id ).hide();
		
		if (_g_ime.pluginMouse_use_YN) {
            alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Support!!!!!');
            ime._blur();
        }
        else {
            alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Not Support!!!!! ');
        }
		
		imeRetrunString  = string;
		var popObj = $.sfScene.get("G_PopUp");
		popObj.setString(imeRetrunString);
		$.sf.returnFocus();				
		$.sfScene.focus("G_PopUp");
    }
    
    var onInfoKey = function(keyCode)
    {
        alert("Info key pressed in " + element.id + ", key code is " + keyCode + ", text is " + element.value);
        ime.setString("Hello world");        
        return true;
    }
	
	var move12KeyPosition = function(arg){
		alert("12key position change : " + arg);
	}
	
	var moveqwertyPosition = function(arg){
		alert("qwerty position change : " + arg);
	}	
}

var IME_Load =
{
    elementIds : null,
    inputs : new Array(),
    ready : new Array(),
	flag : null,
}

var array = ["PopUpETTInputBox"];

IME_Load.enterFunc = function(string)
{
    alert("IMEIMEIMEIMEIME :  Enter  KEY PRESSED"); 
	SceneController.ShowPopUpScene(); 
}           

IME_Load.returnFunc = function()
{
    alert("IMEIMEIMEIMEIME :  RETURN  KEY PRESSED");     
    $("#"+ "PopUpETTInputBox").hide();    
    
    if (_g_ime.pluginMouse_use_YN) {
        alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Support!!!!!');
        ime._blur();
    }
    else {
        alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Not Support!!!!! ');
    }
	
	var popObj = $.sfScene.get("G_PopUp");
	popObj.returnFromIME();
	$.sf.returnFocus();				
	$.sfScene.focus("G_PopUp");	                
} 

IME_Load.exitFunc = function()
{
    alert("IMEIMEIMEIMEIME :  Exit  KEY PRESSED");        
	var popObj = $.sfScene.get("G_PopUp");
	
	if (_g_ime.pluginMouse_use_YN) {
        alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Support!!!!!');
        ime._blur();
    }
    else {
        alert('@@@@@@@@@@@@@@@@[openPopup] Mouse Not Support!!!!! ');
    }
	
	popObj.popupID = null;
	$.sf.returnFocus();	
	popObj.handleReturnKey();
}                                          

IME_Load.onLoad = function(flag, arr)
{
    alert("IMEIMEIMEIMEIME : IME_Load.onLoad()");   
    this.elementIds = arr;
	this.flag = flag;
	document.getElementById(this.elementIds[0]).value  = imeRetrunString;    
    $("#"+ this.elementIds[0]).show();
	

    this.createInputObjects();
	return;
}

IME_Load.onUnload = function()
{
    alert("IMEIMEIMEIMEIME : IME_Load.onUnload()");
}


IME_Load.createInputObjects = function()
{
	var totalElem = this.elementIds.length;
    for (var idx =(totalElem-1); idx >=0; idx--)
    {
        var prevIdx = idx - 1;
        if (prevIdx < 0)
        {   
            prevIdx = totalElem - 1;
        }
        var nextIdx = (idx + 1) % totalElem;       
        alert("IMEIMEIMEIMEIME : prevIndex " + prevIdx + "  index " + idx + "  nextIndex " + nextIdx);       
        IME_Load.inputs[idx] = new Input( this.elementIds[idx], this.elementIds[prevIdx], this.elementIds[nextIdx] );
    }
	
    idx = 0;
}

IME_Load.ready = function(id){
	var ready = true;
	for (var i in this.elementIds) {
	
		if (this.elementIds[i] == id) {
			this.ready[i] = true;
		}
		
		if (this.ready[i] == false) {
			ready = false;
		}
	}
	
	if (_g_ime.pluginMouse_use_YN) {
		alert('@@@@@@@@@@@@@@@@[new IMEshell] Mouse Support!!!!!');
		ime._focus();
	}
	else {
		alert('@@@@@@@@@@@@@@@@[new IMEshell] Mouse Not Support!!!!! ');
		if (ready) {
			_$(id).focus();
		}
	}
}                                         