
var Logger = new Class({

    Singleton : true,

    enabled: null,
		
    initialize: function()
    {
        // To turn off all console features, set Console.enabled to false.
        this.enabled = true;
    },
    
    // Console.log(object[, object, ...]) - Print a message in the log. If
    // FireBug is enabled, print the message in the FireBug
    // console. Otherwise, do nothing.
    log: function () 
    {
        if (this.enabled) 
            this.handle("[CAMERAAPP] ",arguments);
    },
    
    // Console.debug(object[, object, ...]) - Writes a message to the
    // FireBug console, including a hyperlink to the line where it was called.
    debug: function () 
    {
        if (this.enabled) 
            this.handle("DEBUG",arguments);
    },

    // Console.info(object[, object, ...]) - Writes a message to the
    // console with the visual "info" icon and color coding and a
    // hyperlink to the line where it was called.
    info: function () 
    {
        if (this.enabled) 
            this.handle("INFO",arguments);
    },

    // Console.warn(object[, object, ...]) - Writes a message to the
    // console with the visual "warning" icon and color coding and a
    // hyperlink to the line where it was called.
    warn: function () 
    {
        if (this.enabled) 
            this.handle("WARN",arguments);
    },

    // Console.error(object[, object, ...]) - Writes a message to the
    // console with the visual "error" icon and color coding and a
    // hyperlink to the line where it was called. If FireBug is not
    // enabled, an alert box is displayed, requesting that the user enable
    // FireBug to debug the problem.
    error: function () 
    {
        if (this.enabled) 
            this.handle("ERROR",arguments);
    },
    
    handle: function(fn,arguments) {
        if (window.console && window.console.error) {
            switch(fn) {
                case "LOG":
                    console.log.apply(console, arguments);
                    break;
                case "DEBUG":
                    console.debug.apply(console, arguments);
                    break;
                case "INFO":
                    console.info.apply(console, arguments);
                    break;
                case "WARN":
                    console.warn.apply(console, arguments);
                    break;
            }
        } else {
            alert(fn+": "+arguments[0]);
        }
    }
});

if(!this.logger) {
	this.logger = new Logger();
}

function _$(objDiv){
    return document.getElementById(objDiv);
}
