var finishTime = 0;
var Player =
{
    plugin : null,
    state : -1,
    skipState : -1,
    stopCallback : null,    /* Callback function to be set by client */
    bExecFuncOnce : false,
    timeoutID : null,
    originalSource : null,
    isBuffering : false,
    fwspeed:0,
    totalTime:0,
    currentTime:0,
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4,
    SKIPFORWARD: 5,
    SKIPREWIND: 6,
	progBarWidth:0,
	seekProgBarWidth:0
}

Player.init = function(){
    alert("$$$$$$$$$$$$$$$$$Player.init((((((((((((((((((*************************************");
    var success = true;    
    this.state = this.STOPPED;    
    this.plugin = document.getElementById("pluginObjectPlayer");  
    alert("**********this.plugin*******************Player"+this.plugin);
    if (!this.plugin) {
         success = false;
    } 
    this.plugin.OnCurrentPlayTime = 'Player.setPlayTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
    this.plugin.OnRenderingComplete = 'Player.onRenderingComplete';
            
    return success;
}

Player.deinit = function(){
	var mwPlugin = document.getElementById("pluginObjectTVMW");
	this.bExecFuncOnce = false;	
	finishTime = 0;
	this.progBarWidth = 0;
	this.seekProgBarWidth = 0;	
	if (mwPlugin && (this.originalSource != null) ){
		/* Restore original TV source before closing the widget */
		mwPlugin.SetSource(this.originalSource);
		alert("Restore source to " + this.originalSource);
	}
}

Player.setWindow = function(){
	alert("Player.setWindow function start");
	if(SceneFocused.IS_CAMERA==true) {
		this.plugin.SetDisplayArea(0, 0, 1920, 1080);
	}else{
		this.plugin.SetDisplayArea(0, 90, 960, 450);
	}
}

Player.setFullscreen = function(){
    if(SceneFocused.IS_CAMERA==true) {
		this.plugin.SetDisplayArea(0, 0, 1920, 1080);
	}else{
		this.plugin.SetDisplayArea(0, 0, 960, 540);
	}
}

Player.setVideoURL = function(url){
    this.url = url;       
	 alert("****&&&&&********Player*************&&***URL = " + this.url);
}

Player.playVideo = function(){
    if (this.url == null){
        alert("No videos to play");
    }else{
		$('#SpeedText').text("");
        this.state = this.PLAYING;
		this.fwspeed=1;
		var ret=this.plugin.SetPlaybackSpeed(this.fwspeed); 		
		alert("************this.url************Play time="+this.url);
        var playValue = this.plugin.Play(this.url);
		alert("**********playValue******************"+playValue);
    }
}

Player.pauseVideo = function(){
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no pause Video");
		return;
	}
	alert("Player.pauseVideo function");	
    this.state = this.PAUSED;
	this.fwspeed = 1;
	var ret=this.plugin.SetPlaybackSpeed(this.fwspeed); 	
    this.plugin.Pause();
}

Player.stopVideo = function(){
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no stop Video");
		return;
	}
    if (this.state != this.STOPPED){
        this.state = this.STOPPED;
        this.plugin.Stop();
		this.isBuffering = false;
        if (this.stopCallback){
            this.stopCallback();
        }
    }else{
        alert("Ignoring stop request, not in correct state");
    }
}

Player.resumeVideo = function(){
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no resume Video");
		return;
	}
    this.state = this.PLAYING;	
	alert("**********Player.resumeVideo*****this.state*************"+this.state);
    this.plugin.Resume();
}

Player.skipForwardVideo = function(seekTime){
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no skip Forward Video");
		return;
	}
    this.plugin.JumpForward(seekTime);
	if(this.state == this.PAUSED){
		var playSceneObj = $.sfScene.get('G_PlayScene');
		playSceneObj.playVideo();
		this.state = this.PLAYING;
	}
	//this.state = this.FORWARD;
}

Player.skipBackwardVideo = function(seekTime){
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no skip Backward Video");
		return;
	}
    this.plugin.JumpBackward(seekTime);
	if(this.state == this.PAUSED){
		var playSceneObj = $.sfScene.get('G_PlayScene');
		playSceneObj.playVideo();
		this.state = this.PLAYING;
	}
	//this.state = this.REWIND;
}

Player.getState = function(){
    return this.state;
}

// Global functions called directly by the player 
Player.onBufferingStart = function(){
	this.isBuffering = true;
	switch(this.skipState){
		case this.FORWARD:
			document.getElementById("forward").style.opacity = '0.2';
			break;      
		case this.REWIND:
			document.getElementById("rewind").style.opacity = '0.2';
			break;
	}
}

Player.onBufferingProgress = function(percent){
}

Player.onBufferingComplete = function(){
	 var totalTime =  this.plugin.GetDuration();
	 alert("Player.onBufferingComplete"+ totalTime );
	 this.totalTime = totalTime;
	 this.isBuffering = false;
}

Player.setTotalTime = function(totalTime){
	this.totalTime = totalTime;
}

Player.forwardVideo = function(){        
	alert("In player.forwardvideo  ==  fwspeed=="+this.fwspeed);
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no forward");
		return;
	}	
	this.state = this.FORWARD;
	_$('StatusIcon').style.backgroundImage = "url('./images/player/player_video_icon_ff.png')";
	if(this.fwspeed==2){
		this.fwspeed=4;
		$('#SpeedText').text("2");
	}else if(this.fwspeed==4){
		this.fwspeed=8;
		$('#SpeedText').text("3");
	}else{
		this.fwspeed=2;
		$('#SpeedText').text("1");
	}  
    
	var ret=this.plugin.SetPlaybackSpeed(this.fwspeed);    
	alert("After setplaybackspeed fwspeed=="+this.fwspeed+"****-----ret="+ret);   
}

Player.rewindVideo = function(){
	alert("In player.rewindVideo  ==  fwspeed=="+this.fwspeed);
	if(this.isBuffering == true){
		alert("Player buffering in progress so return and no rewind");
		return;
	}
	this.state = this.REWIND; 
	_$('StatusIcon').style.backgroundImage = "url('./images/player/player_video_icon_rew.png')";	
	if(this.fwspeed==-2){
		this.fwspeed=-4;
		$('#SpeedText').text("2");
	}else if(this.fwspeed==-4){
		this.fwspeed=-8;
		$('#SpeedText').text("3");
	}else{
		this.fwspeed=-2;
		$('#SpeedText').text("1");
	}	

	var ret=this.plugin.SetPlaybackSpeed(this.fwspeed);    
	alert("After setplaybackspeed fwspeed=="+this.fwspeed+"****ret------"+ret);
}

onServerError = function(){
	this.isBuffering = false;
}
OnNetworkDisconnected = function(){
	this.isBuffering = false;
}
getBandwidth = function(bandwidth) { 
	alert("getBandwidth " + bandwidth); 
}
onDecoderReady = function(){ 
	alert("onDecoderReady");
}
onRenderError = function() { 
	this.isBuffering = false;
	alert("onRenderError"); 
}

stopPlayer = function(){
    Player.stopVideo();
	this.isBuffering = false;
}

setTottalBuffer = function(buffer) { 
	alert("setTottalBuffer " + buffer); 
}

setCurBuffer = function(buffer) { 
	alert("setCurBuffer " + buffer); 
}

Player.setPlayTime = function(time){
	if((this.bExecFuncOnce==true)&&(this.state == this.FORWARD)) {
		return;
	}
	alert("Before clear Timeout in player.js");
	clearTimeout(this.timeoutID);
	this.bExecFuncOnce = false;
	alert("Inside setPlayTime HAHAHAHAHHAHHAHAH"+time);
	alert("Inside setPlayTime HAHAHAHAHHAHHAHAH"+this.totalTime);
	//var centerwidth = 0;    
	var timePercent = parseInt(time/this.totalTime * 100);    	
	this.progBarWidth = time*621/this.totalTime;	
	if(this.progBarWidth < this.seekProgBarWidth) {
		_$('playscene-barcenter').setStyle("width",this.seekProgBarWidth);
		_$('playscene-barright').setStyle("left",(2+this.seekProgBarWidth));
	} else {
		_$('playscene-barcenter').setStyle("width",this.progBarWidth);
		_$('playscene-barright').setStyle("left",(2+this.progBarWidth));
	}
	this.currentTime = time/1000;
	var stoptime = formatDuration(time);
	var totaltime = "/"+formatDuration(this.totalTime);
	var remTime = this.totalTime - time;
	finishTime = this.totalTime;
	$('#CurrentTime').text(stoptime);
	$('#TotalTime').text(totaltime);
	if(remTime < 10000) {
		if(this.fwspeed==8 || this.fwspeed==4) {
			this.bExecFuncOnce = true;
			this.timeoutID = setTimeout('Player.showComplete()', 1000);
		} else if(timePercent>=100) {
			this.bExecFuncOnce = true;
			Player.showPrevScene();
		}
	}
	if(time<2000){
		if(this.state == this.REWIND){
			_$('playscene-barright').setStyle("left",2);		
			Player.resetTimer();
			_$('StatusIcon').style.backgroundImage = "url('./images/player/player_icon_play.png')";
			Player.playVideo();
		}
	}
}
  
Player.showComplete  =  function(){  
	alert("Inside Player.showComplete function()");
	_$("playscene-barcenter").style.width="621px"; 
	_$("playscene-barright").style.left="623px"; 
	$('#CurrentTime').text(formatDuration(finishTime));
	this.timeoutID = setTimeout('Player.showPrevScene()', 1000);
}
      
Player.showPrevScene  =  function(){  
	alert("Inside Player.showPrevScene function()");
	if(SceneFocused.IS_CAMERA==true){
		var camObj = $.sfScene.get('C_Camera');
		camObj.handleRetPlayer();
	}else if(SceneFocused.IS_PLAYSCENE==true){				
		var playSceneObj = $.sfScene.get('G_PlayScene');
		playSceneObj.handleReturn();
	}
}		
		
Player.resetTimer =  function(){    
	alert("Player.resetTimer function");    
    $('#playscene-barcenter').css("width",0);   
    $('#CurrentTime').text("00:00:00");
    $('#TotalTime').text("/00:00:00");
}

Player.onRenderingComplete = function(){
	 alert("$$$$$$$$$$$$$$$$$$$$$$ Player.onRenderingComplete $$$$$$$$$$$$$$$$$$$$$$$");
	 /*if(SceneFocused.IS_PLAYSCENE==true) {
		 var playSceneObj = $.sfScene.get('G_PlayScene');
		 playSceneObj.handleReturn();
	 }*/
}

Player.PlayAfterTime = function(x) {
	var seekPosRatio = (x-463)/625;
	var seekTime = Math.round(seekPosRatio*finishTime/1000);
	this.seekProgBarWidth = x-463;
	alert("SEEK TIME PLAYER IS %%%%%%%%%%%%%%%%%%%%%%% "+ seekTime);
	_$('playscene-barcenter').setStyle("width",this.seekProgBarWidth);
	_$('playscene-barright').setStyle("left",(2+this.seekProgBarWidth));
	var jumpTime = seekTime - this.currentTime;
	if(jumpTime<0) {
		this.skipBackwardVideo(-jumpTime);
	} else {
		this.skipForwardVideo(jumpTime);
	}
	this.state = this.PLAYING;
}
