/**
****************************************************************************
* @file         ScrollBar.js
* @brief        Implementation of scroll bar.
*
* Copyright 2011 by Samsung Electronics, Inc.,
* 
* This software is the confidential and proprietary information
* of Samsung Electronics, Inc. ("Confidential Information").  You
* shall not disclose such Confidential Information and shall use
* it only in accordance with the terms of the license agreement
* you entered into with Samsung.
*
* @author       subhash.c
* @date         13/06/2011
* Change History        
* Date              By                      Reason
* 13/06/2011        Subhash Chandra         created
****************************************************************************/

var scrBarInstance = 0;//Scroll bar instance number

/**
****************************************************************************
* @class       ScrollBar
* @brief       interface of the scroll barclass
* @author      subhash.c
* @date        13/06/2011
****************************************************************************
*/
var ScrollBar = new Class({

    Singleton : true,

    scrollHeight:null,
    scrollBarTop:null,
    scrollBarId:null,
    scrollBarTopId:null,
    scrollBarInId:null,
    scrollBarBtmId:null,
    ScrollBar:null,
	
	scrollBacgrdHeight:null,
    scrollBarBacgrdTop:null,
    scrollBarBacgrdId:null,
    scrollBarBacgrdTopId:null,
    scrollBarBacgrdInId:null,
    scrollBarBacgrdBtmId:null,
    ScrollBarBacgrd:null,
	
    parDiv:null,
		
    initialize: function(parentId, scrollHeight, listHeight, left,top)
    {
        this.parDiv =_$(parentId);
		logger.log("Inside scroller"+this.parDiv);
        if(!this.parDiv) 
		{
            return;
        }
		
		
		
		//*************************Background DIV***********************//
		this.scrollBacgrdHeight = scrollHeight;
        this.scrollBarBacgrdTop = 0;
        this.scrollBarBacgrdId = "scrollBarBacgrd_" + scrBarInstance;
        this.scrollBarBacgrdTopId = "scrollBarTopBacgrd_" + scrBarInstance;
        this.scrollBarBacgrdInId = "scrollBarInBacgrd_" + scrBarInstance;
        this.scrollBarBacgrdBtmId = "scrollBarBtmBacgrd_" + scrBarInstance;
        logger.log("scrollBar Bacgrd scrollHeight " + scrollHeight + " listHeight " + listHeight);
        this.parDiv.style.position = "absolute";
        this.parDiv.style.visibility = "visible";
        scrBarInstance++;
        var ScrollBarBacgrdTopImg = "./images/cameraTV/scroll_bg_01.png";	
        var ScrollBarBacgrdInImg = "./images/cameraTV/scroll_bg_02.png";
        var ScrollBarBacgrdBtmImg = "./images/cameraTV/scroll_bg_03.png";

        this.ScrollBarBacgrd = document.createElement("div");
        this.ScrollBarBacgrd.setAttribute('id', this.scrollBarBacgrdId);

        var ScrollBarBacgrdTop = document.createElement("div");
        ScrollBarBacgrdTop.setAttribute('id', this.scrollBarBacgrdTopId);

        var scrollBarBacgrdIn = document.createElement("div");
        scrollBarBacgrdIn.setAttribute('id', this.scrollBarBacgrdInId);

        var scrollBarBacgrdBtm = document.createElement("div");
        scrollBarBacgrdBtm.setAttribute('id', this.scrollBarBacgrdBtmId);

        this.ScrollBarBacgrd.appendChild(ScrollBarBacgrdTop);
        this.ScrollBarBacgrd.appendChild(scrollBarBacgrdIn);
        this.ScrollBarBacgrd.appendChild(scrollBarBacgrdBtm);

        this.parDiv.appendChild(this.ScrollBarBacgrd);

        
        this.ScrollBarBacgrd.style.height = scrollHeight + "px";
        this.ScrollBarBacgrd.style.width = "4px";
        this.ScrollBarBacgrd.style.position = "absolute";
        this.ScrollBarBacgrd.style.top = top+ "px";
        this.ScrollBarBacgrd.style.left = left + "px";
		//this.ScrollBar.style.border =  "2px solid red";

        var scrollBarBacgrdTopDiv = document.getElementById(this.scrollBarBacgrdTopId);
        scrollBarBacgrdTopDiv.style.height = "2px";
        scrollBarBacgrdTopDiv.style.width = "4px";
        scrollBarBacgrdTopDiv.style.top = "0px";
        scrollBarBacgrdTopDiv.style.left = "0px";
        scrollBarBacgrdTopDiv.style.position = "absolute";
        scrollBarBacgrdTopDiv.style.backgroundImage = "url("+ScrollBarBacgrdTopImg +")";
		//scrollBarTopDiv.style.border =  "2px solid green";

        var scrollBarBacgrdInDiv = document.getElementById(this.scrollBarBacgrdInId);
        scrollBarBacgrdInDiv.style.height = scrollHeight - 4 + "px";
        scrollBarBacgrdInDiv.style.width = "4px";
        scrollBarBacgrdInDiv.style.top = "2px";
        scrollBarBacgrdInDiv.style.left = "0px";
        scrollBarBacgrdInDiv.style.position = "absolute";
        scrollBarBacgrdInDiv.style.backgroundImage = "url("+ScrollBarBacgrdInImg +")";
        scrollBarBacgrdInDiv.style.backgroundRepeat = "repeat-y";

        var scrollBarBacgrdBtmDiv = document.getElementById(this.scrollBarBacgrdBtmId);
        scrollBarBacgrdBtmDiv.style.height = "2px";
        scrollBarBacgrdBtmDiv.style.width = "4px";
        scrollBarBacgrdBtmDiv.style.left = "0px";
        scrollBarBacgrdBtmDiv.style.top = scrollHeight - 2 + "px";
        scrollBarBacgrdBtmDiv.style.position = "absolute";
        scrollBarBacgrdBtmDiv.style.backgroundImage = "url("+ScrollBarBacgrdBtmImg +")";
		
		//***************************END********************************//
		this.scrollHeight = scrollHeight;
        this.scrollBarTop = 0;
        this.scrollBarId = "scrollBar_" + scrBarInstance;
        this.scrollBarTopId = "scrollBarTop_" + scrBarInstance;
        this.scrollBarInId = "scrollBarIn_" + scrBarInstance;
        this.scrollBarBtmId = "scrollBarBtm_" + scrBarInstance;
        logger.log("scrollBar scrollHeight " + scrollHeight + " listHeight " + listHeight);
        this.parDiv.style.position = "absolute";
        this.parDiv.style.visibility = "visible";
        scrBarInstance++;
        var ScrollBarTopImg = "./images/cameraTV/scroll_01.png";	
        var ScrollBarInImg = "./images/cameraTV/scroll_02.png";
        var ScrollBarBtmImg = "./images/cameraTV/scroll_03.png";

        this.ScrollBar = document.createElement("div");
        this.ScrollBar.setAttribute('id', this.scrollBarId);

        var ScrollBarTop = document.createElement("div");
        ScrollBarTop.setAttribute('id', this.scrollBarTopId);

        var scrollBarIn = document.createElement("div");
        scrollBarIn.setAttribute('id', this.scrollBarInId);

        var scrollBarBtm = document.createElement("div");
        scrollBarBtm.setAttribute('id', this.scrollBarBtmId);

        this.ScrollBar.appendChild(ScrollBarTop);
        this.ScrollBar.appendChild(scrollBarIn);
        this.ScrollBar.appendChild(scrollBarBtm);

        this.ScrollBarBacgrd.appendChild(this.ScrollBar);

        var scrollBarHt =   scrollHeight * (scrollHeight / listHeight);
        this.scrollBarMaxY = scrollHeight - scrollBarHt;
        this.scrollProportion = this.scrollBarMaxY / (listHeight - scrollHeight);

        this.ScrollBar.style.height = scrollBarHt + "px";
        this.ScrollBar.style.width = "4px";
        this.ScrollBar.style.position = "absolute";
        this.ScrollBar.style.top = "0px";
        this.ScrollBar.style.left = "0px";
		//this.ScrollBar.style.border =  "2px solid red";

        var scrollBarTopDiv = document.getElementById(this.scrollBarTopId);
        scrollBarTopDiv.style.height = "2px";
        scrollBarTopDiv.style.width = "4px";
        scrollBarTopDiv.style.top = "0px";
        scrollBarTopDiv.style.left = "0px";
        scrollBarTopDiv.style.position = "absolute";
        scrollBarTopDiv.style.backgroundImage = "url("+ScrollBarTopImg +")";
		//scrollBarTopDiv.style.border =  "2px solid green";

        var scrollBarInDiv = document.getElementById(this.scrollBarInId);
        scrollBarInDiv.style.height = scrollBarHt - 4 + "px";
        scrollBarInDiv.style.width = "4px";
        scrollBarInDiv.style.top = "2px";
        scrollBarInDiv.style.left = "0px";
        scrollBarInDiv.style.position = "absolute";
        scrollBarInDiv.style.backgroundImage = "url("+ScrollBarInImg +")";
        scrollBarInDiv.style.backgroundRepeat = "repeat-y";

        var scrollBarBtmDiv = document.getElementById(this.scrollBarBtmId);
        scrollBarBtmDiv.style.height = "2px";
        scrollBarBtmDiv.style.width = "4px";
        scrollBarBtmDiv.style.left = "0px";
        scrollBarBtmDiv.style.top = scrollBarHt - 2 + "px";
        scrollBarBtmDiv.style.position = "absolute";
        scrollBarBtmDiv.style.backgroundImage = "url("+ScrollBarBtmImg +")";
		//scrollBarBtmDiv.style.border = "2px solid Blue";
    },
    
  /**
*****************************************************************************
* @fn           setScrollBarPos
* @brief        set the Scroll bar position
* @param        none
* @return       none
*****************************************************************************
*/
    setScrollBarPos:function(pos) {
        logger.log("1 setScrollBarPos = "+ pos);
        if(pos < 0 || pos > this.scrollHeight/this.scrollProportion) {
            return;
        }

        var tempScroll =  pos * this.scrollProportion;
        var tempTop = parseInt(tempScroll);
        //if(tempTop >= 0) {
        if(tempTop >= this.scrollBarTop) {
            if(tempTop > this.scrollBarMaxY) {
                tempTop = this.scrollBarMaxY;
            }
            this.ScrollBar.style.top = tempTop + "px";
        }
    },

    /**
*****************************************************************************
* @fn               resizeBar
* @brief            resize the scroll bar
* @param[in]        listHeight:-height of list(in which scroll bar moves)
* @return           none
*****************************************************************************
*/
    resizeBar:function(listHeight) {
        var scrollHeight = this.scrollHeight;
        var scrollBarHt = scrollHeight * (scrollHeight / listHeight);
        this.scrollBarMaxY = scrollHeight - scrollBarHt;
        this.scrollProportion = this.scrollBarMaxY / (listHeight - scrollHeight);
        this.ScrollBar.style.height = scrollBarHt + "px";

        var scrollBarInDiv = document.getElementById(this.scrollBarInId);
        scrollBarInDiv.style.height = scrollBarHt - 4 + "px";

        var scrollBarBtmDiv = document.getElementById(this.scrollBarBtmId);
        scrollBarBtmDiv.style.top = scrollBarHt - 2 + "px";
        this.setScrollBarPos(0);
    },

    /**
*****************************************************************************
* @fn               show
* @brief            Show the scroll bar
* @param[in]        bShow:-true or false
* @return           none
*****************************************************************************
*/
    show:function(bShow) {
        var strVisible = this.parDiv.style.visibility;
        if((strVisible == "visible" && bShow) || (strVisible == "hidden" && !bShow)) {
            return;
        }
        if(bShow) {
            this.parDiv.style.visibility = "visible";
        }
        else {
            this.parDiv.style.visibility = "hidden";
        }
    } 
});

if(!this.scrollBar) {
	this.scrollBar = new ScrollBar();
}