function SceneF_DurationTimeWnd (options)
{
	alert("==== SceneF_DurationTimeWnd =====");
	this.options = options;
	this.DurationTimeView = null;


	this.LogoText = null;
	
	this.DurationSec = null;
	
	this.DurationBgLeft = null;
	this.DurationBgCenter = null;
	this.DurationBgRight = null;
	
	this.DurationTitleText = null;
	this.DurationTimeText = null;
	
	this.HourData = null;
	this.MinData = null;
	this.SecData = null;
	
	this.DurationFlag = false;
}


SceneF_DurationTimeWnd.prototype.initialize = function () 
{
	this.create();
}

SceneF_DurationTimeWnd.prototype.handleShow = function()
{
	alert("==== SceneF_DurationTimeWnd.handleShow()");
	this.durationStart();
}

SceneF_DurationTimeWnd.prototype.handleHide = function () 
{
	alert("==== SceneF_DurationTimeWnd.handleHide()");
	this.stopTimers();
}

SceneF_DurationTimeWnd.prototype.handleFocus = function () 
{
	alert("==== SceneF_DurationTimeWnd.handleFocus()");
}

SceneF_DurationTimeWnd.prototype.handleBlur = function () 
{
	alert("==== SceneF_DurationTimeWnd.handleBlur()");
}

SceneF_DurationTimeWnd.prototype.handleKeyDown = function (keyCode) 
{
	if(event.keyCode != 0){
		keyCode = convert(event.keyCode);
	}
	switch (keyCode)
	{
		
		case $.sfKey.RED:
			break;
		
		case $.sfKey.GREEN:
			break;
		
		case $.sfKey.YELLOW:
			break;				
			
		case $.sfKey.BLUE:
			break;
		
		case $.sfKey.ENTER:
			break;
		
		case $.sfKey.RETURN:
			break;
        case $.sfKey.EXIT:
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
			break;			

		default:
			break;
	}
}

SceneF_DurationTimeWnd.prototype.highlight=function(obj)
{
	alert("==== SceneF_DurationTimeWnd.highlight()");
    this.DurationTimeView.setCurrentHighlight(obj);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneF_DurationTimeWnd.prototype.create = function()
{
	alert("==== SceneF_DurationTimeWnd.create()");
	this.DurationTimeView = new View('F_DurationTimeWnd');

	this.LogoText = new TextLayer('DurationTimeWnd_logo');
	this.LogoText.SetText(SID_MY_MIRROR);

	this.DurationBgLeft = new ImageLayer('DurationTimeWnd_indicator_bg_left');
	this.DurationBgLeft.SetBgImage(IMAGE_FOLLOWTV_DURATION_LEFT);
	this.DurationBgCenter = new ImageLayer('DurationTimeWnd_indicator_bg_center');
	this.DurationBgCenter.SetBgImage(IMAGE_FOLLOWTV_DURATION_CENTER);
	this.DurationBgRight = new ImageLayer('DurationTimeWnd_indicator_bg_right');
	this.DurationBgRight.SetBgImage(IMAGE_FOLLOWTV_DURATION_RIGHT);
	
	this.DurationTitleText = new TextLayer('DurationTimeWnd_indicator_text_title');
	this.DurationTitleText.SetText(SID_THE_DURATION)
	
	this.DurationTimeText = new TextLayer('DurationTimeWnd_indicator_text_time');
	
	
	alert("==== SceneF_DurationTimeWnd.create() : END");
}
SceneF_DurationTimeWnd.prototype.checkStringByte = function(string)
{
	alert("==== SceneF_DurationTimeWnd.checkStringByte() : START");

	var stringLength = string.length;
	var count = 0;
	for (var i = 0; i < stringLength; i++) 
	{
		var ch = string.charCodeAt(i);
		if (escape(ch).length > 4) 
		{
			count += 2;
		}
		else 
		{
			count++;
		}
	}
	alert("==== SceneF_DurationTimeWnd.checkStringByte() : string = "+string);
	alert("==== SceneF_DurationTimeWnd.checkStringByte() : length = "+stringLength);
	alert("==== SceneF_DurationTimeWnd.checkStringByte() : byte = "+count);
	return count;
}

SceneF_DurationTimeWnd.prototype.durationStart = function()
{
	alert("==== SceneF_DurationTimeWnd.durationStart()");
	if (this.DurationFlag == false) 
	{
		this.DurationFlag = true;
		this.resetDuration();
		this.DurationSec = setInterval(this.updateDurationTime, 1000);
	}
	alert("==== SceneF_DurationTimeWnd.durationStart() : END");
}

SceneF_DurationTimeWnd.prototype.resetDuration = function()
{
	alert("==== SceneF_DurationTimeWnd.resetDuration()");
	this.HourData = 0;
	this.MinData = 0;
	this.SecData = 0;
	this.updateDurationText();
}

SceneF_DurationTimeWnd.prototype.stopTimers = function()
{
	alert("==== SceneF_DurationTimeWnd.stopTimers()");
	if (this.DurationFlag == true) 
	{
		this.DurationFlag = false;
		clearInterval(this.DurationSec);
		this.resetDuration();
	}
}


SceneF_DurationTimeWnd.prototype.updateDurationTime = function()
{
	var durationTimeScene = $.sfScene.get('F_DurationTimeWnd');
	
	durationTimeScene.SecData = (1 + durationTimeScene.SecData)%60;
	if (durationTimeScene.SecData == 0)
	{
		durationTimeScene.MinData = (1 + durationTimeScene.MinData)%60;
		if (durationTimeScene.MinData == 0)
		{
			durationTimeScene.HourData = 1 + durationTimeScene.HourData; 
		}
	}
	
	/*	
	alert("==== SceneF_DurationTimeWnd.updateSec() : this.SecData = "+durationTimeScene.SecData);
	alert("==== SceneF_DurationTimeWnd.updateSec() : this.MinData = "+durationTimeScene.MinData);
	alert("==== SceneF_DurationTimeWnd.updateSec() : this.HourData = "+durationTimeScene.HourData);
	*/
	$.sfScene.get('F_DurationTimeWnd').updateDurationText();
}


SceneF_DurationTimeWnd.prototype.updateDurationText = function()
{
	var HourString = this.HourData;
	var MinString = this.MinData;
	var SecString = this.SecData;
	
	if (this.HourData < 10)
	{
		HourString = "0"+this.HourData;
	}
	if (this.MinData < 10)
	{
		MinString = "0"+this.MinData;
	}
	if (this.SecData < 10)
	{
		SecString = "0"+this.SecData;
	}
	alert("==== SceneF_DurationTimeWnd.updateDurationText : "+this.HourData+":"+this.MinData+":"+this.SecData+" --> "+HourString+":"+MinString+":"+SecString);
	this.DurationTimeText.SetText(HourString+":"+MinString+":"+SecString);
}

SceneF_DurationTimeWnd.prototype.processReturnKey = function()
{
	alert("==== SceneF_DurationTimeWnd.processReturnKey();");
	$.sfKey.block(event);
}

SceneF_DurationTimeWnd.prototype.processExitKey = function()
{
	alert("==== SceneF_DurationTimeWnd.processExitKey();");
	ProcMgr.processExitKey();
}

