
function SceneF_TwoButtonPopup (options)
{
	alert("==== SceneF_TwoButtonPopup =====");
	this.options = options;
	this.TwoButtonPopupView = null;
	this.TwoButtonPopupBgImg = null;
	this.TwoButtonPopupText = null;
	
	
	this.YesBtn = null;
	this.NoBtn = null;
	this.PopupType = null;
	
	this.CloseWndTimer = null;
}


SceneF_TwoButtonPopup.prototype.initialize = function () 
{
	this.create();
}

SceneF_TwoButtonPopup.prototype.handleShow = function()
{
	alert("==== SceneF_TwoButtonPopup.handleShow()");
	_$('TwoButtonPopup_popup_alpha').style.opacity = opacityValue;
	this.highlight(this.YesBtn);
	this.startTimer();
	
	
	ReverseDirection.reverse('F_TwoButtonPopup', true);
}

SceneF_TwoButtonPopup.prototype.handleHide = function () 
{
	this.stopTimer();
	alert("==== SceneF_TwoButtonPopup.handleHide()");
}

SceneF_TwoButtonPopup.prototype.handleFocus = function () 
{
	alert("==== SceneF_TwoButtonPopup.handleFocus()");
}

SceneF_TwoButtonPopup.prototype.handleBlur = function () 
{
	alert("==== SceneF_TwoButtonPopup.handleBlur()");
}

SceneF_TwoButtonPopup.prototype.handleKeyDown = function (keyCode) 
{
	if(event.keyCode != 0){
		keyCode = convert(event.keyCode);
	}
	switch (keyCode)
	{
		case $.sfKey.LEFT:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.processRightKey();
			break;
		case $.sfKey.ENTER:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			this.processEnterKey();
			break;
		case $.sfKey.RETURN:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.processReturnKey();
			break;
		case $.sfKey.EXIT:
			this.processExitKey();
			break;
		case 147: //infolink
		case 261: //contents
		case 115: //wiselink
			break;
		default:
			break;
	}
}

SceneF_TwoButtonPopup.prototype.highlight=function(obj)
{
	alert("SceneF_TwoButtonPopup.highlight()");
    this.TwoButtonPopupView.setCurrentHighlight(obj);
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneF_TwoButtonPopup.prototype.create = function()
{
	alert("==== SceneF_TwoButtonPopup.create()");
	this.TwoButtonPopupView = new View('F_TwoButtonPopup');
		
	this.TwoButtonPopupBgImg = new NinePatchPopup('TwoButtonPopup_popup', POPUP_IMG_TYPE.NINE, BUTTON_TYPE.TWO);
	this.TwoButtonPopupBgImg.SetTopBgImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_LT, IMAGE_FOLLOWTV_MESSAGE_POPUP_CT, IMAGE_FOLLOWTV_MESSAGE_POPUP_RT);
	this.TwoButtonPopupBgImg.SetCenterBgImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_LC, IMAGE_FOLLOWTV_MESSAGE_POPUP_CC, IMAGE_FOLLOWTV_MESSAGE_POPUP_RC);
	this.TwoButtonPopupBgImg.SetBottomBgImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_LB, IMAGE_FOLLOWTV_MESSAGE_POPUP_CB, IMAGE_FOLLOWTV_MESSAGE_POPUP_RB);
	this.TwoButtonPopupBgImg.SetTopAlphaImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_LT, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_CT, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_RT);
	this.TwoButtonPopupBgImg.SetCenterAlphaImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_LC, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_CC, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_RC);
	this.TwoButtonPopupBgImg.SetBottomAlphaImage(IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_LB, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_CB, IMAGE_FOLLOWTV_MESSAGE_POPUP_ALPHA_RB);
	
	this.TwoButtonPopupText = new TextLayer('TwoButtonPopup_popup_text');
	this.TwoButtonPopupText.SetText(SID_CANCEL_RECORDING);


	var clickYesCF = function(obj)
	{
		$.sfScene.get('F_TwoButtonPopup').processYes();
	};
	var clickNoCF = function(obj)
	{
		$.sfScene.get('F_TwoButtonPopup').processNo();
	};
	this.YesBtn = new ThreeImageButton();
	this.YesBtn.Create("TwoButtonPopup_popup_yes");
	this.YesBtn.SetThreeBgImage(BUTTON_BASE_STATE.NORMAL ,IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_L, IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_C, IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_R);
	this.YesBtn.SetThreeBgImage(BUTTON_BASE_STATE.HIGHLIGHT ,IMAGE_FOLLOWTV_POPUP_BTN_SELECT_L, IMAGE_FOLLOWTV_POPUP_BTN_SELECT_C, IMAGE_FOLLOWTV_POPUP_BTN_SELECT_R);
	this.YesBtn.SetText(SID_YES);	
	this.YesBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL , "TwoButtonPopup_popup_nor");
	this.YesBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT , "TwoButtonPopup_popup_highlight");
	this.YesBtn.SetOnClickCallbackFunc(clickYesCF);
	
	this.NoBtn = new ThreeImageButton();
	this.NoBtn.Create("TwoButtonPopup_popup_no");
	this.NoBtn.SetThreeBgImage(BUTTON_BASE_STATE.NORMAL ,IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_L, IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_C, IMAGE_FOLLOWTV_POPUP_BTN_NORMAL_R);
	this.NoBtn.SetThreeBgImage(BUTTON_BASE_STATE.HIGHLIGHT ,IMAGE_FOLLOWTV_POPUP_BTN_SELECT_L, IMAGE_FOLLOWTV_POPUP_BTN_SELECT_C, IMAGE_FOLLOWTV_POPUP_BTN_SELECT_R);
	this.NoBtn.SetText(SID_NO);	
	this.NoBtn.SetTextStyle(BUTTON_BASE_STATE.NORMAL , "TwoButtonPopup_popup_nor");
	this.NoBtn.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT , "TwoButtonPopup_popup_highlight");
	this.NoBtn.SetOnClickCallbackFunc(clickNoCF);
	

	alert("==== SceneF_TwoButtonPopup.create() : END");
}

SceneF_TwoButtonPopup.prototype.startTimer = function()
{
    alert("==== SceneF_TwoButtonPopup.startTimer() : this.CloseWndTimer = "+this.CloseWndTimer);
    if (this.CloseWndTimer == null) 
	{
		this.CloseWndTimer = setTimeout("CloseTimerCF()", 30000);
		CloseTimerCF = function()
		{
			$.sfScene.get('F_TwoButtonPopup').processNo();
		}
	}
	else
	{
		alert("SceneF_TwoButtonPopup.startTimer() : RETURN : ELSE");	
	}
}

SceneF_TwoButtonPopup.prototype.stopTimer = function()
{
    alert("==== SceneF_TwoButtonPopup.stopTimer() : this.CloseWndTimer = "+this.CloseWndTimer);
    if (this.CloseWndTimer != null) 
	{
		clearTimeout(this.CloseWndTimer);
		this.CloseWndTimer = null;
	}
	else
	{
		alert("SceneF_TwoButtonPopup.stopTimer() : RETURN : ELSE");	
	}
}

SceneF_TwoButtonPopup.prototype.processLeftKey = function()
{
	alert("==== SceneF_TwoButtonPopup.processLeftKey()");
	var currentHighlight = this.TwoButtonPopupView.getCurrentHighlight();
	switch (currentHighlight)
	{
		case this.YesBtn:
			alert("==== SceneF_TwoButtonPopup.processLeftKey() : YES");
			break;
		case this.NoBtn:
			alert("==== SceneF_TwoButtonPopup.processLeftKey() : NO");
			this.highlight(this.YesBtn);
			break;
	}
}

SceneF_TwoButtonPopup.prototype.processRightKey = function()
{
	alert("==== SceneF_TwoButtonPopup.processRightKey()");
	var currentHighlight = this.TwoButtonPopupView.getCurrentHighlight();
	switch (currentHighlight)
	{
		case this.YesBtn:
			alert("==== SceneF_TwoButtonPopup.processRightKey() : YES");
			this.highlight(this.NoBtn);
			break;
		case this.NoBtn:
			alert("==== SceneF_TwoButtonPopup.processRightKey() : NO");
			break;
	}
}

SceneF_TwoButtonPopup.prototype.processEnterKey = function()
{
	alert("==== SceneF_TwoButtonPopup.processEnterKey()");
	var currentHighlight = this.TwoButtonPopupView.getCurrentHighlight();
	switch(currentHighlight)
	{
		case this.YesBtn:
			alert("==== SceneF_TwoButtonPopup.processEnterKey() : YES");
			this.processYes();
			break;
			
		case this.NoBtn:
			alert("==== SceneF_TwoButtonPopup.processEnterKey() : NO");
			this.processNo();
			break;

	}
}
SceneF_TwoButtonPopup.prototype.processYes = function()
{
	alert("==== SceneF_TwoButtonPopup.processYes() : 1");
	$.sfScene.get('F_CaptureBtnWnd').suddenStopRecording();
	this.processNo();
	ProcMgr.BackfromFollowTVtoCameraApp();
}
SceneF_TwoButtonPopup.prototype.processNo = function()
{
	alert("==== SceneF_TwoButtonPopup.processNo()");
	if (this.CloseWndTimer == null) 
	{
		alert("==== SceneF_TwoButtonPopup.processNo() : this.CloseWndTimer == "+this.CloseWndTimer);
		return;
	}
	this.stopTimer();
	WndMgr.FollowTV.HideTwoButtonPopup();
}


SceneF_TwoButtonPopup.prototype.processReturnKey = function()
{
	alert("==== SceneF_TwoButtonPopup.processReturnKey();");
	$.sfKey.block(event);
	this.processNo();
}

SceneF_TwoButtonPopup.prototype.processExitKey = function()
{
	alert("==== SceneF_TwoButtonPopup.processExitKey();");
	this.processReturnKey();
	//ProcMgr.processExitKey();
}

