var toolbartimer=null;
var prevScene = null;

function SceneG_PlayScene(options) {
	this.options = options;
	this.previousView = null;
	this.videoURL = null;
	this.videoTitle = null;
	this.playerHelpBar = null;
	this.PlayState=false;
}

SceneG_PlayScene.prototype.initialize = function () {
	alert("SceneG_PlayScene.initialize()");
	this.playerHelpBar = new CameraHelpBar(CameraHelpBarIndex.G_PLAYER_WND, "player-helpbar", IMAGE_HELP_BAR_BG_BLACK);
	var this_ = $.sfScene.get("G_PlayScene");
	this.playerHelpBar.SetOnClickCallbackFunc(1, function(){this_.handleKeyDown($.sfKey.RETURN);});
}

SceneG_PlayScene.prototype.handleShow = function () {
	alert("SceneG_PlayScene.handleShow()");
	SceneFocused.IS_PLAYSCENE=true;
	this.createToolBar();
	//_$('FileNameText').set('text',replaceWhiteSpace(this.videoTitle));
	_$('FileNameText').innerHTML = replaceWhiteSpace(this.videoTitle);
	$.sfService.setVolumeControl(true);
	Player.init();
	Player.setFullscreen();
	Player.setVideoURL(this.videoURL);
	this.playVideo();
	this.PlayState =true;
	this.playerHelpBar.EnableOnClick();
	this.addMouseEvent();
	this.showToolBar();
}

SceneG_PlayScene.prototype.handleHide = function () {
	alert("SceneG_PlayScene.handleHide()");
	SceneFocused.IS_PLAYSCENE=false;
	$.sfService.setVolumeControl(false);
	this.destroyToolBar();	
	this.playerHelpBar.DisableOnClick();	
}

SceneG_PlayScene.prototype.handleFocus = function () {
	alert("SceneG_PlayScene.handleFocus()");
}

SceneG_PlayScene.prototype.handleBlur = function () {
	alert("SceneG_PlayScene.handleBlur()");
}

// ADD 05/08 Jang
 SceneG_PlayScene.prototype.PauseFn = function () {
	alert("SceneG_PlayScene.PauseFn()");
	PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
	this.showToolBar();
	$('#SpeedText').text("");
	_$('StatusIcon').style.backgroundImage = "url('./images/player/player_video_icon_pause.png')";
	Player.pauseVideo();
	this.PlayState =false;
}

// ADD 05/08 Jang
SceneG_PlayScene.prototype.PlayFn = function () {
	alert("SceneG_PlayScene.PlayFn()");
	PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
	alert("PLAY Key pressed in playscene");
	this.showToolBar();
	this.playVideo();
	this.PlayState =true;
}




SceneG_PlayScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneG_PlayScene.prototype.handleKeyDown :: " + keyCode);
	alert("event.keyCode :: " + event.keyCode);
	if(event.keyCode != 0){
		keyCode = convert(event.keyCode);
	}
	alert("SceneG_PlayScene.handleKeyDown(" + keyCode + ")");
	switch (keyCode) {
		case $.sfKey.LEFT:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.showToolBar();
			Player.skipBackwardVideo(10);
			break;
		
		case $.sfKey.RIGHT:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.showToolBar();
			Player.skipForwardVideo(10);
			break;
			
		case $.sfKey.UP:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.showToolBar();
			break;
			
		case $.sfKey.DOWN:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.showToolBar();
			break;
			
		case $.sfKey.ENTER:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			this.showToolBar();
			break;
			
		case $.sfKey.PAUSE:
			alert("Pause Key pressed in playscene");
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			this.showToolBar();
			$('#SpeedText').text("");
			_$('StatusIcon').style.backgroundImage = "url('./images/player/player_video_icon_pause.png')";
			Player.pauseVideo();
			this.PlayState =false;
			break;
			
		case $.sfKey.PLAY:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			alert("PLAY Key pressed in playscene");
			this.showToolBar();
			this.playVideo();
			this.PlayState =true;
			break;
			
		case $.sfKey.STOP:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			this.showToolBar();
			this.handleReturn();
			break;
			
		case $.sfKey.FF:	
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			this.showToolBar();			
			if(Player.getState()==2){
				Player.resumeVideo();
			}
			Player.forwardVideo();
			break;
			
		case $.sfKey.RW:	
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_SELECT);
			this.showToolBar();			
			if(Player.getState()==2){
				Player.resumeVideo();
			}
			Player.rewindVideo();
			break;
			
        case $.sfKey.RETURN:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			event.preventDefault();
			this.handleReturn();
            break;
			
		case $.sfKey.EXIT:
		case $.sfKey.INFOLINK:
			PluginAPIMgr.AUIPlayAudio(ENUM_AUI_AUDIO_TYPE.AUDIO_TYPE_SMARTCONTROL_MOVE);
			event.preventDefault();
			Player.stopVideo();
			Player.deinit();			
			ProcMgr.processExitKey();
			break;
	}
}

SceneG_PlayScene.prototype.createToolBar = function(){
	
	if(_$("TopBanner")==null){
		var self = $.sfScene.get("G_PlayScene");
		var playScene = _$('SceneG_PlayScene');
		
		var playerInfoBar = new Element('div');
		playerInfoBar.set('id',"PlayerInfoBar");
		
		var playSceneTopBanner = new Element('div');
		playSceneTopBanner.set('id',"TopBanner");
		
		var playSceneFileName = new Element('div');
		playSceneFileName.set('id',"FileName");
		
		var playSceneFileNameText = new Element('div');
		playSceneFileNameText.set('id',"FileNameText");
		
		playSceneFileName.adopt(playSceneFileNameText);

		var playSceneStatusIcon = new Element('div');
		playSceneStatusIcon.set('id',"StatusIcon");
		
		var playSceneSpeedText = new Element('div');
		playSceneSpeedText.set('id',"SpeedText");

		var playsceneVideoTimer = new Element('div');
		playsceneVideoTimer.set('id',"VideoTimer");
		
		var playSceneCurrentTime = new Element('div');
		playSceneCurrentTime.set('id',"CurrentTime");
		
		var playSceneTotalTime = new Element('div');
		playSceneTotalTime.set('id',"TotalTime");
		
		playsceneVideoTimer.adopt(playSceneCurrentTime);
		playsceneVideoTimer.adopt(playSceneTotalTime);
		
		var playerProgressArea = new Element('div');
		playerProgressArea.set('id',"PlayerProgressArea");
		
		var playSceneBarBg = new Element('div');
		playSceneBarBg.set('id',"playscene-bar-bg");
		
		var playSceneBarBgLeft = new Element('div');
		playSceneBarBgLeft.set('id',"playscene-bar-bgleft");
		
		var playSceneBarBgCenter = new Element('div');
		playSceneBarBgCenter.set('id',"playscene-bar-bgcenter");
		
		var playSceneBarBgRight = new Element('div');
		playSceneBarBgRight.set('id',"playscene-bar-bgright");
		
		playSceneBarBg.adopt(playSceneBarBgLeft);
		playSceneBarBg.adopt(playSceneBarBgCenter);
		playSceneBarBg.adopt(playSceneBarBgRight);
		
		playerProgressArea.adopt(playSceneBarBg);
		
		var playSceneBar = new Element('div');
		playSceneBar.set('id',"playscene-bar");
		
		var playSceneBarLeft = new Element('div');
		playSceneBarLeft.set('id',"playscene-barleft");
		
		var playSceneBarCenter = new Element('div');
		playSceneBarCenter.set('id',"playscene-barcenter");
		
		var playSceneBarRight = new Element('div');
		playSceneBarRight.set('id',"playscene-barright");
		
		playSceneBar.adopt(playSceneBarLeft);
		playSceneBar.adopt(playSceneBarCenter);
		playSceneBar.adopt(playSceneBarRight);
		
		playerProgressArea.adopt(playSceneBar);
		
		playerInfoBar.adopt(playSceneTopBanner);
		playerInfoBar.adopt(playSceneFileName);
		playScene.adopt(playerInfoBar);
		
		playSceneTopBanner.adopt(playSceneStatusIcon);
		playSceneTopBanner.adopt(playSceneSpeedText);
		playSceneTopBanner.adopt(playsceneVideoTimer);
		playSceneTopBanner.adopt(playerProgressArea);
		
		_$("PlayerProgressArea").onclick = function(){self.mouseCBProgressBarFn()};
		$("#PlayerProgressArea").css({'cursor': 'pointer'});		
	}
	_$('StatusIcon').style.backgroundImage = "url('./images/player/player_icon_play.png')";
	_$('FileNameText').set('text',this.videoTitle);
}

SceneG_PlayScene.prototype.startPlayerAnimation = function() {
	if(_$('PlayerInfoBar').style.visibility != "visible") {
		_$('PlayerInfoBar').style.visibility = "visible";
		$('#PlayerInfoBar').animate({
			top : "0px"
		}, 500);
	}
}

SceneG_PlayScene.prototype.showToolBar = function(){
	if(_$("TopBanner")!=null){
		clearTimeout(toolbartimer);
		toolbartimer = null;
		this.startPlayerAnimation();		
		toolbartimer = setTimeout("SceneG_PlayScene.prototype.hideToolBar()",10000);
	}
}

SceneG_PlayScene.prototype.hideToolBar = function(){
	if(_$("PlayerInfoBar")!=null){
		$('#PlayerInfoBar').css('top', "-90px");
		_$('PlayerInfoBar').style.visibility = "hidden";
	}
}

SceneG_PlayScene.prototype.destroyToolBar = function(){
	clearTimeout(toolbartimer);
	toolbartimer = null;
	if(_$("PlayerInfoBar")!=null){
		_$("PlayerInfoBar").destroy();
	}
	alert("destroy toolbar finished");
}

SceneG_PlayScene.prototype.setPreviousView = function(view){
	this.previousView = view;
}

SceneG_PlayScene.prototype.setVideoURLNtitle = function(url,title){
	this.videoURL = url;
	this.videoTitle = title;
}

SceneG_PlayScene.prototype.playVideo = function(){
	_$('StatusIcon').style.backgroundImage = "url('./images/player/player_icon_play.png')";
	$('#SpeedText').text("");
	alert("******=====Player.getState()*******======"+Player.getState());
	if(Player.getState()==2){ 
		Player.resumeVideo();
	}else if(Player.getState()==0 || Player.getState()==3 || Player.getState()==4){
		Player.playVideo();
	}
}

SceneG_PlayScene.prototype.handleReturn = function()
{
	alert("SceneG_PlayScene.prototype.handleReturn this.previousView ======" + this.previousView);
	Player.resetTimer();
	this.destroyToolBar();	
	prevScene = this.previousView;
	this.previousView = null;
	var timeoutID = setTimeout('SceneG_PlayScene.prototype.setPrevView()', 500);
}

SceneG_PlayScene.prototype.setPrevView = function()
{
	Player.stopVideo();
	Player.deinit();
	SceneController.HidePlayScene();

	if(prevScene=="MYVIDEO"){
		SceneController.ShowMyVideoScene();
	}else if(prevScene=="GALLERYALL"){
		SceneController.ShowGalleryAllScene();
	}else if(prevScene=="CAMERA"){
		var cameraObj = $.sfScene.get('C_Camera');	
		if(cameraObj.viewmode==1){
			PluginAPIMgr.CameraViewSize(0,0,1920,1080);
		}else{
			PluginAPIMgr.CameraViewSize(343,25,1235,693);
		}						
		PluginAPIMgr.SetCamProperty(ENUM_CAM_PROPERTY_TYPE.CAM_PROPERTY_DIMENSION,1280,720);			
		PluginAPIMgr.GetSetting();		
		PluginAPIMgr.StartCamVideo("1","2");	
		SceneController.ShowCameraScene();			
	}
	prevScene = null;
}

SceneG_PlayScene.prototype.updateUSBList = function()
{
	alert("SceneG_PlayScene.prototype.handleReturn this.previousView ======" + this.previousView);
	if(eventType==ENUM_USB_EVENT.CURRENT_USB_REMOVED || eventType==ENUM_USB_EVENT.NO_USB)
	{
		Player.stopVideo();
		Player.deinit();
		SceneController.HidePlayScene();
		if(this.previousView=="MYVIDEO"){
			var viewObj = $.sfScene.get('G_MyVideo');
			viewObj.updateUSBList();
		}else if(this.previousView=="GALLERYALL"){
			var viewObj = $.sfScene.get('G_GalleryAll');
			viewObj.updateUSBList();
			viewObj = $.sfScene.get('C_Camera');
			viewObj.updateUSBList();
		}else if(this.previousView=="CAMERA"){
			var cameraObj = $.sfScene.get('C_Camera');
			if(cameraObj.viewmode==1){
				PluginAPIMgr.CameraViewSize(0,0,1920,1080);
			}else{
				PluginAPIMgr.CameraViewSize(343,25,1235,693);
			}
			PluginAPIMgr.SetCamProperty(ENUM_CAM_PROPERTY_TYPE.CAM_PROPERTY_DIMENSION,1280,720);			
			PluginAPIMgr.GetSetting();		
			PluginAPIMgr.StartCamVideo("1","2");
			cameraObj.updateUSBList();	
			SceneController.ShowCameraScene();
		}
		this.previousView = null;
	}
}

SceneG_PlayScene.prototype.processVoiceRecogResultPlayScene = function(tmp)
{
	var self = $.sfScene.get('G_PlayScene');
	deviceapis.recognition.HideVoiceHelpbar();
	alert("SceneG_PlayScene.prototype.processVoiceRecogResult::: " +tmp);
//	var this_ = $.sfScene.get("G_PlayScene");
		
	switch(tmp) {
		case recog.SID_PLAY:
			this.PlayFn();
		//	this_.handleKeyDown($.sfKey.PLAY);
		//	self.handleKeyDown($.sfKey.PLAY);
			break;
		case recog.SID_PAUSE:
			this.PauseFn();
		//	this_.handleKeyDown($.sfKey.PAUSE);
		//	self.handleKeyDown($.sfKey.PAUSE);
			break;		
	}
}

SceneG_PlayScene.prototype.addMouseEvent = function()
{
	alert("*****PlayScene View****  addMouseEvent : " );
	var this_ = $.sfScene.get("G_PlayScene");
	_$("StatusIcon").onclick = function(){this_.mouseCallBackFn()};
	$("#StatusIcon").css({'cursor': 'pointer'});
}

SceneG_PlayScene.prototype.mouseCBProgressBarFn = function()
{
	var evtClick = window.event;
	var xCoord = evtClick.clientX;
	alert("****PlayScene****View****  mouseCBProgressBarFn with x coordinate : " + xCoord);
	Player.PlayAfterTime(xCoord);
}

SceneG_PlayScene.prototype.mouseCallBackFn = function()
{
	alert("****PlayScene****View****  mouseCallBackFn : ---");
	if(this.PlayState==true)
	{
		alert("****Play State****:::::Call Pause Fn : ---");
		this.handleKeyDown($.sfKey.PAUSE);
	}
	else
	{
		alert("****Pause State****:::::Call Play Fn : ---");
		this.handleKeyDown($.sfKey.PLAY);		
	}
}